VERSION 5.00
Begin VB.UserControl KeyPress 
   CanGetFocus     =   0   'False
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   990
   InvisibleAtRuntime=   -1  'True
   Picture         =   "KeyPress.ctx":0000
   ScaleHeight     =   480
   ScaleWidth      =   990
   ToolboxBitmap   =   "KeyPress.ctx":0442
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   525
      Top             =   0
   End
End
Attribute VB_Name = "KeyPress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'KeyPress.ctl
'by Phlip Bradbury phlipping@yahoo.com
'
'Raises KeyDown and KeyUp events regardless of which
'application has the focus.
'
'Properties:
'  Interval - How often to check for keypresses
'             Lower values may slow down your computer,
'             but I only have a P150 and I notice no
'             slowdown with Interval=1. Higher Intervals
'             may miss some keypresses.
'  Enabled - Whether to check for keys at all
'
'Events:
'  KeyDown - Raised when a keystate changes from up to down
'  KeyUp - Raised when a keystate changes from down to up
Option Explicit
'GAKS is easier to type than GetAsyncKeyState
Private Declare Function GAKS Lib "User32" Alias "GetAsyncKeyState" (ByVal vKey As KeyCodeConstants) As Long
'stores previous state of each key
Private KeyIsDown(0 To 255) As Boolean
'stores name of each key as a string
Private KeyNames(0 To 255) As String
'The timer should only be enabled if the app is running.
'If the app is in design mode, then disable the timer and
'store the enabled property here:
Private ShouldBeEnabled As Boolean

Public Event KeyDown(ByVal KeyCode As KeyCodeConstants)
Public Event KeyUp(ByVal KeyCode As KeyCodeConstants)

'handy for telling the user what is what
Public Property Get KeyName(ByVal vKey As KeyCodeConstants) As String
  KeyName = KeyNames(vKey)
End Property

'standard function call to make GetAsyncKeyState work
Public Function IsKeyDown(ByVal vKey As KeyCodeConstants) As Boolean
  IsKeyDown = GAKS(vKey) And &H8000
End Function

Private Sub Timer1_Timer()
  Dim I As Integer, A As Boolean
  'check each key
  For I = 0 To 255
    A = IsKeyDown(I)
    'if the key state has changed, raise event
    If A And Not KeyIsDown(I) Then
      KeyIsDown(I) = True
      RaiseEvent KeyDown(I)
    ElseIf Not A And KeyIsDown(I) Then
      KeyIsDown(I) = False
      RaiseEvent KeyUp(I)
    End If
  Next
End Sub

Private Sub UserControl_Initialize()
  Dim I As Integer
  'All keys start up
  For I = 0 To 255
    KeyIsDown(I) = False
  Next
  
  'Hard code Key names
  KeyNames(0) = "None"
  KeyNames(1) = "LMouse"
  KeyNames(2) = "RMouse"
  KeyNames(3) = "MMouse"
  KeyNames(4) = "None"
  KeyNames(5) = "None"
  KeyNames(6) = "None"
  KeyNames(7) = "None"
  KeyNames(8) = "Bksp"
  KeyNames(9) = "Tab"
  KeyNames(10) = "None"
  KeyNames(11) = "None"
  KeyNames(12) = "None"
  KeyNames(13) = "Enter"
  KeyNames(14) = "None"
  KeyNames(15) = "None"
  KeyNames(16) = "Shift"
  KeyNames(17) = "Ctrl"
  KeyNames(18) = "Alt"
  KeyNames(19) = "Num"
  KeyNames(20) = "Caps"
  KeyNames(21) = "None"
  KeyNames(22) = "None"
  KeyNames(23) = "None"
  KeyNames(24) = "None"
  KeyNames(25) = "None"
  KeyNames(26) = "None"
  KeyNames(27) = "Escape"
  KeyNames(28) = "None"
  KeyNames(29) = "None"
  KeyNames(30) = "None"
  KeyNames(31) = "None"
  KeyNames(32) = "Space"
  KeyNames(33) = "PgUp"
  KeyNames(34) = "PgDn"
  KeyNames(35) = "End"
  KeyNames(36) = "Home"
  KeyNames(37) = "Left"
  KeyNames(38) = "Up"
  KeyNames(39) = "Right"
  KeyNames(40) = "Down"
  KeyNames(41) = "None"
  KeyNames(42) = "None"
  KeyNames(43) = "None"
  KeyNames(44) = "PrtSc"
  KeyNames(45) = "Ins"
  KeyNames(46) = "Del"
  KeyNames(47) = "None"
  KeyNames(48) = "0"
  KeyNames(49) = "1"
  KeyNames(50) = "2"
  KeyNames(51) = "3"
  KeyNames(52) = "4"
  KeyNames(53) = "5"
  KeyNames(54) = "6"
  KeyNames(55) = "7"
  KeyNames(56) = "8"
  KeyNames(57) = "9"
  KeyNames(58) = "None"
  KeyNames(59) = "None"
  KeyNames(60) = "None"
  KeyNames(61) = "None"
  KeyNames(62) = "None"
  KeyNames(63) = "None"
  KeyNames(64) = "None"
  KeyNames(65) = "A"
  KeyNames(66) = "B"
  KeyNames(67) = "C"
  KeyNames(68) = "D"
  KeyNames(69) = "E"
  KeyNames(70) = "F"
  KeyNames(71) = "G"
  KeyNames(72) = "H"
  KeyNames(73) = "I"
  KeyNames(74) = "J"
  KeyNames(75) = "K"
  KeyNames(76) = "L"
  KeyNames(77) = "M"
  KeyNames(78) = "N"
  KeyNames(79) = "O"
  KeyNames(80) = "P"
  KeyNames(81) = "Q"
  KeyNames(82) = "R"
  KeyNames(83) = "S"
  KeyNames(84) = "T"
  KeyNames(85) = "U"
  KeyNames(86) = "V"
  KeyNames(87) = "W"
  KeyNames(88) = "X"
  KeyNames(89) = "Y"
  KeyNames(90) = "Z"
  KeyNames(91) = "None"
  KeyNames(92) = "None"
  KeyNames(93) = "None"
  KeyNames(94) = "None"
  KeyNames(95) = "None"
  KeyNames(96) = "Num0"
  KeyNames(97) = "Num1"
  KeyNames(98) = "Num2"
  KeyNames(99) = "Num3"
  KeyNames(100) = "Num4"
  KeyNames(101) = "Num5"
  KeyNames(102) = "Num6"
  KeyNames(103) = "Num7"
  KeyNames(104) = "Num8"
  KeyNames(105) = "Num9"
  KeyNames(106) = "Num*"
  KeyNames(107) = "Num+"
  KeyNames(108) = "NumEnter"
  KeyNames(109) = "Num-"
  KeyNames(110) = "NumDot"
  KeyNames(111) = "Num/"
  KeyNames(112) = "F1"
  KeyNames(113) = "F2"
  KeyNames(114) = "F3"
  KeyNames(115) = "F4"
  KeyNames(116) = "F5"
  KeyNames(117) = "F6"
  KeyNames(118) = "F7"
  KeyNames(119) = "F8"
  KeyNames(120) = "F9"
  KeyNames(121) = "F10"
  KeyNames(122) = "F11"
  KeyNames(123) = "F12"
  KeyNames(124) = "None"
  KeyNames(125) = "None"
  KeyNames(126) = "None"
  KeyNames(127) = "None"
  KeyNames(128) = "None"
  KeyNames(129) = "None"
  KeyNames(130) = "None"
  KeyNames(131) = "None"
  KeyNames(132) = "None"
  KeyNames(133) = "None"
  KeyNames(134) = "None"
  KeyNames(135) = "None"
  KeyNames(136) = "None"
  KeyNames(137) = "None"
  KeyNames(138) = "None"
  KeyNames(139) = "None"
  KeyNames(140) = "None"
  KeyNames(141) = "None"
  KeyNames(142) = "None"
  KeyNames(143) = "None"
  KeyNames(144) = "Num"
  KeyNames(145) = "Scroll"
  KeyNames(146) = "None"
  KeyNames(147) = "None"
  KeyNames(148) = "None"
  KeyNames(149) = "None"
  KeyNames(150) = "None"
  KeyNames(151) = "None"
  KeyNames(152) = "None"
  KeyNames(153) = "None"
  KeyNames(154) = "None"
  KeyNames(155) = "None"
  KeyNames(156) = "None"
  KeyNames(157) = "None"
  KeyNames(158) = "None"
  KeyNames(159) = "None"
  KeyNames(160) = "None"
  KeyNames(161) = "None"
  KeyNames(162) = "None"
  KeyNames(163) = "None"
  KeyNames(164) = "None"
  KeyNames(165) = "None"
  KeyNames(166) = "None"
  KeyNames(167) = "None"
  KeyNames(168) = "None"
  KeyNames(169) = "None"
  KeyNames(170) = "None"
  KeyNames(171) = "None"
  KeyNames(172) = "None"
  KeyNames(173) = "None"
  KeyNames(174) = "None"
  KeyNames(175) = "None"
  KeyNames(176) = "None"
  KeyNames(177) = "None"
  KeyNames(178) = "None"
  KeyNames(179) = "None"
  KeyNames(180) = "None"
  KeyNames(181) = "None"
  KeyNames(182) = "None"
  KeyNames(183) = "None"
  KeyNames(184) = "None"
  KeyNames(185) = "None"
  KeyNames(186) = ";"
  KeyNames(187) = "+"
  KeyNames(188) = "<"
  KeyNames(189) = "-"
  KeyNames(190) = ">"
  KeyNames(191) = "?"
  KeyNames(192) = "~"
  KeyNames(193) = "None"
  KeyNames(194) = "None"
  KeyNames(195) = "None"
  KeyNames(196) = "None"
  KeyNames(197) = "None"
  KeyNames(198) = "None"
  KeyNames(199) = "None"
  KeyNames(200) = "None"
  KeyNames(201) = "None"
  KeyNames(202) = "None"
  KeyNames(203) = "None"
  KeyNames(204) = "None"
  KeyNames(205) = "None"
  KeyNames(206) = "None"
  KeyNames(207) = "None"
  KeyNames(208) = "None"
  KeyNames(209) = "None"
  KeyNames(210) = "None"
  KeyNames(211) = "None"
  KeyNames(212) = "None"
  KeyNames(213) = "None"
  KeyNames(214) = "None"
  KeyNames(215) = "None"
  KeyNames(216) = "None"
  KeyNames(217) = "None"
  KeyNames(218) = "None"
  KeyNames(219) = "{"
  KeyNames(220) = "\"
  KeyNames(221) = "}"
  KeyNames(222) = """"
  KeyNames(223) = "None"
  KeyNames(224) = "None"
  KeyNames(225) = "None"
  KeyNames(226) = "None"
  KeyNames(227) = "None"
  KeyNames(228) = "None"
  KeyNames(229) = "None"
  KeyNames(230) = "None"
  KeyNames(231) = "None"
  KeyNames(232) = "None"
  KeyNames(233) = "None"
  KeyNames(234) = "None"
  KeyNames(235) = "None"
  KeyNames(236) = "None"
  KeyNames(237) = "None"
  KeyNames(238) = "None"
  KeyNames(239) = "None"
  KeyNames(240) = "None"
  KeyNames(241) = "None"
  KeyNames(242) = "None"
  KeyNames(243) = "None"
  KeyNames(244) = "None"
  KeyNames(245) = "None"
  KeyNames(246) = "None"
  KeyNames(247) = "None"
  KeyNames(248) = "None"
  KeyNames(249) = "None"
  KeyNames(250) = "None"
  KeyNames(251) = "None"
  KeyNames(252) = "None"
  KeyNames(253) = "None"
  KeyNames(254) = "None"
  KeyNames(255) = "None"
End Sub

'Enable timer only if app is running
Private Sub UserControl_InitProperties()
  If Ambient.UserMode Then Timer1.Enabled = ShouldBeEnabled
End Sub

'Lock size to size of image
Private Sub UserControl_Resize()
  Height = 480
  Width = 480
End Sub

Public Property Get Interval() As Long
Attribute Interval.VB_Description = "Returns/sets the number of milliseconds between calls to a Timer control's Timer event."
  Interval = Timer1.Interval
End Property

Public Property Let Interval(ByVal New_Interval As Long)
  Timer1.Interval() = New_Interval
  PropertyChanged "Interval"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
  Enabled = ShouldBeEnabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
  Dim I As Integer
  ShouldBeEnabled = New_Enabled
  Timer1.Enabled = ShouldBeEnabled And Ambient.UserMode
  If Not New_Enabled Then
    'Set all keystates to up
    For I = 0 To 255
      If KeyIsDown(I) Then
        KeyIsDown(I) = False
        RaiseEvent KeyUp(I)
      End If
    Next
  End If
  PropertyChanged "Enabled"
End Property

'save/load properties
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Timer1.Interval = PropBag.ReadProperty("Interval", 1)
  Enabled = PropBag.ReadProperty("Enabled", True)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "Interval", Timer1.Interval, 1
  PropBag.WriteProperty "Enabled", ShouldBeEnabled, True
End Sub

